import { buildUUID } from '../../../utils/uuid';
import { ApiActionPage } from '../../model/baseModel';
import {
  MeslineListItem,
  MeslinePageParams,
  MeslinePageListGetResultModel,
} from '../model/mesModel';
import { genAction, Api, genActionPage } from '../system';
import { defHttp } from '/@/utils/http/axios';
import { useUserStore } from '../../../store/modules/user';

/*
 * 获取产线分页列表
 */
export const getMeslineListByPage = async (params: MeslinePageParams) => {
  let sqlcmd = '';
  if (params?.LINE_CODE != undefined && params?.LINE_CODE != '') {
    sqlcmd += "And LINE_CODE like '%" + params?.LINE_CODE + "%'";
  }
  if (params?.LINE_NAME != undefined && params?.LINE_NAME != '') {
    sqlcmd += "And LINE_NAME like '%" + params?.LINE_NAME + "%'";
  }
  const rParams = genActionPage('MES_RULE', sqlcmd, params.page, params.pageSize);
  return getMeslineListByPageAsync(rParams);
};
async function getMeslineListByPageAsync(params: ApiActionPage) {
  //   const data = await defHttp.post<ApiActionPage>(
  //     { url: Api.EntityPageList, params },
  //     {
  //       isTransformResponse: false,
  //     },
  //   );
  const data: MeslineListItem[] = [
    {
      ID: '1',
      LINE_CODE: 'line0001',
      LINE_NAME: '产线1',
      WORKSHOP_CODE: 'M111',
      FACTORY_CODE: '002',
      ORG_ID: '24',
      SHIFTTYPE_CODE: '',
      LOCATION: '',
      IS_ACTIVE: 'Y',
      CREATE_USER: useUserStore().getUserInfo.userId,
      UPDATE_USER: useUserStore().getUserInfo.userId,
      UPDATE_TIME: '2023-02-06',
      CREATE_TIME: '2023-02-06',
      REMARK: '',
    },
    {
      ID: '2',
      LINE_CODE: 'line0002',
      LINE_NAME: '产线2',
      WORKSHOP_CODE: 'M111',
      FACTORY_CODE: '002',
      ORG_ID: '24',
      SHIFTTYPE_CODE: '',
      LOCATION: '',
      IS_ACTIVE: 'Y',
      CREATE_USER: useUserStore().getUserInfo.userId,
      UPDATE_USER: useUserStore().getUserInfo.userId,
      UPDATE_TIME: '2023-02-06',
      CREATE_TIME: '2023-02-06',
      REMARK: '',
    },
    {
      ID: '3',
      LINE_CODE: 'line0003',
      LINE_NAME: '产线3',
      WORKSHOP_CODE: 'M111',
      FACTORY_CODE: '002',
      ORG_ID: '24',
      SHIFTTYPE_CODE: '',
      LOCATION: '',
      IS_ACTIVE: 'Y',
      CREATE_USER: useUserStore().getUserInfo.userId,
      UPDATE_USER: useUserStore().getUserInfo.userId,
      UPDATE_TIME: '2023-02-06',
      CREATE_TIME: '2023-02-06',
      REMARK: '',
    },
    {
      ID: '4',
      LINE_CODE: 'line0004',
      LINE_NAME: '产线4',
      WORKSHOP_CODE: 'M111',
      FACTORY_CODE: '002',
      ORG_ID: '24',
      SHIFTTYPE_CODE: '',
      LOCATION: '',
      IS_ACTIVE: 'Y',
      CREATE_USER: useUserStore().getUserInfo.userId,
      UPDATE_USER: useUserStore().getUserInfo.userId,
      UPDATE_TIME: '2023-02-06',
      CREATE_TIME: '2023-02-06',
      REMARK: '',
    },
    {
      ID: '5',
      LINE_CODE: 'line0005',
      LINE_NAME: '产线5',
      WORKSHOP_CODE: 'M111',
      FACTORY_CODE: '002',
      ORG_ID: '24',
      SHIFTTYPE_CODE: '',
      LOCATION: '',
      IS_ACTIVE: 'N',
      CREATE_USER: useUserStore().getUserInfo.userId,
      UPDATE_USER: useUserStore().getUserInfo.userId,
      UPDATE_TIME: '2023-02-06',
      CREATE_TIME: '2023-02-06',
      REMARK: '',
    },
  ];
  const model: MeslinePageListGetResultModel = {
    // items: data.Data.data,
    // total: data.Data.totals,
    items: data,
    total: data.length,
  };
  return model;
}
//保存
export const SaveLine = async (params: MeslineListItem, isUpdate: boolean) => {
  let data;
  if (isUpdate) {
    data = await defHttp.post(
      { url: Api.UpdateEntity, params: genAction('MES_LINE', params) },
      {
        errorMessageMode: 'none',
        isTransformResponse: false,
      },
    );
  } else {
    params.ID = buildUUID(); //生成GUID
    params.CREATE_USER = useUserStore().getUserInfo.userId;
    data = await defHttp.post(
      { url: Api.AddEntity, params: genAction('MES_LINE', params) },
      {
        errorMessageMode: 'none',
        isTransformResponse: false,
      },
    );
  }
  return data;
};
//删除
export const DeleteLine = async (params: Recordable) => {
  const usParams = genAction('MES_LINE', [params]);
  return await defHttp.post(
    { url: Api.DeleteList, params: usParams },
    {
      errorMessageMode: 'none',
      isTransformResponse: false,
    },
  );
};
